#ifndef _Innovation
#define _Innovation

#include <vector>
#include "Neuron.h"

using namespace std;

// Link: two node's + innovation_num

class Link {
	
public:
	
	Neuron *incnode,*outnode;
	int innovation_num;

	Link () {}
	Link (Link* lk) {
		incnode=lk->incnode;
		outnode=lk->outnode;
		innovation_num=lk->innovation_num;
	}
	Link (Neuron* inc_n,Neuron* out_n,int innov) {
		incnode=new Neuron(inc_n);
		outnode=new Neuron(out_n);
		innovation_num=innov;
	}
	~Link () {}
};

// node innovation: incnode->midnode->outnode + innovation num of the first link

class LinkAndNode {
	
public:
	
	Neuron *incnode,*midnode,*outnode;
	int innovation_num; // innovation number of the incoming link to the midnode
	
	LinkAndNode () {}
	LinkAndNode (LinkAndNode* ln) {
		incnode=ln->incnode;
		midnode=ln->midnode;
		outnode=ln->outnode;
		innovation_num=ln->innovation_num;
	}
	LinkAndNode (Neuron* inc_n,Neuron* mid_n,Neuron* out_n,int innov) {
		incnode=new Neuron(inc_n);
		midnode=new Neuron(mid_n);
		outnode=new Neuron(out_n);
		innovation_num=innov;
	}
	~LinkAndNode () {}
};

/* Innovation class stores node/link innovations through time for all organisms */

class Innovation {

public:
	
	static vector<Link*> global_link_innovation;
	static vector<LinkAndNode*> global_node_innovation;
	static int cur_innov; // the current (max) link's innovation number
							// (-1 for the initial links)

	Innovation () {}

	~Innovation () {}

};

#endif
