#include "IDCounters.h"
#include "Functions.h"
#include "Innovation.h"
#include "Definitions.h"
#include "Organism.h"
#include "Neat.h"
#include "Population.h"
#include "Experiments.h"
#include "DrawNetwork.h"
#include <cstdlib>

int main(int argc, char** argv) {

	Functions funcs; // initialize the random generator
	IDCounters id_counts; // initialize the counters
	Innovation innov; // initialize the innovations

	NEAT::load_neat_params(argv[1]); // load the experiment's parameters
	int index=0;
	while (argv[1][index]!='_') index++;
	char* nameExp=(char*)malloc((index+1)*sizeof(char));
	for (int i=0; i<index; i++) nameExp[i]=argv[1][i];
	nameExp[index]=0;
	Organism** tabOrg=test(nameExp); // launch the experiment

	if (tabOrg[0]!=0) {
		cout << endl << "Organism " << tabOrg[0]->id << " is the winner, with fitness " << tabOrg[0]->fitness << endl;
		graph(tabOrg[0]);
		tabOrg[0]->print_to_file("the_best.txt");
	}
	else if (tabOrg[1]!=0) {
		cout << endl << "Organism " << tabOrg[1]->id << " is the best candidate, with fitness " << tabOrg[1]->fitness << endl;
		graph(tabOrg[1]);
		tabOrg[1]->print_to_file("best_fit.txt");
	}	

	return 0;
}
