#include "GeneticGene.h"

void Gene::print_to_file(ofstream &outFile) {
	outFile<<"gene ";
	//Start off with the trait number for this gene
	if ((lnk->linktrait)==0) outFile<<"0 ";
	else outFile<<((lnk->linktrait)->trait_id)<<" ";
	outFile<<(lnk->in_node)->node_id<<" ";
	outFile<<(lnk->out_node)->node_id<<" ";
	outFile<<(lnk->weight)<<" ";
	outFile<<(lnk->is_recurrent)<<" ";
	outFile<<innovation_num<<" ";
	outFile<<mutation_num<<" ";
	outFile << enable << endl;
}

//Gene printing method
ostream& operator<< (ostream& os, const Gene *thegene) {
	Link *thelink=thegene->lnk;
	NNode *inode=thelink->in_node;
	NNode *onode=thelink->out_node;
	cout<<"[Link ("<<inode->node_id<<", "<<onode->node_id<<") INNOV ("<<thegene->innovation_num<<", "<<thegene->mutation_num<<")";
	cout<<" Weight "<<(thegene->lnk)->weight;
	if (((thegene->lnk)->linktrait)!=0) std::cout<<" Link's trait_id "<<((thegene->lnk)->linktrait)->trait_id;
	if (thegene->enable==false) cout<<"-DISABLED-";
	if (((thegene->lnk)->is_recurrent)) cout<<"RECUR";
	cout <<"]" << endl;
	return os;
}
