#ifndef	_Dirty
#define	_Dirty

#include <SDL/SDL.h>
#include <cstdlib>

/* Approximate worth of one dirtyrect in pixels. */
#define	PIG_WORST_MERGE		300

/*
 * If the merged result gets at most this many percent
 * bigger than the larger of the two input rects,
 * accept it as Perfect.
 */
#define	PIG_INSTANT_MERGE	10

/* A table of dirtyrects for one display page */
struct Dirtytable {
	int		size;	/* Table size */
	SDL_Rect	*rects;	/* Table of rects */
	int		count;	/* # of rects currently used */
	int		best;	/* Merge testing starts here! */
};

Dirtytable *dirty_open(int size);
void dirty_close(Dirtytable *dt);

/* Add rectangle 'dr' to table 'pdt' */
void dirty_add(Dirtytable *dt, SDL_Rect *dr);

/* Merge table 'from' into 'pdt' */
void dirty_merge(Dirtytable *dt, Dirtytable *from);

/* Extend 'to' to a new rect that includes both 'from' and 'to' */
void mergerect(SDL_Rect *from, SDL_Rect *to);

/* Clip 'to' into a rect that is the intersection of 'from' and 'to' */
void intersectrect(SDL_Rect *from, SDL_Rect *to);

#endif
