#ifndef _Experiments
#define _Experiments

#include <iostream>
#include <fstream>
#include <list>
#include "Neuron.h"
#include "Functions.h"
#include "IDCounters.h"
#include "Innovation.h"
#include "Organism.h"
#include "Species.h"
#include "Population.h"
#include "Neat.h"
#include "Timer.h"
#include "Fighter.h"
#include "PigEval.h"

using namespace std;

//#define DETAILS // prints details about organisms' perfomances in file "trace.txt"
//#define FILE_OUT // outputs some generations in files <gen_num>_<run_num>.txt

//the generic testing function
Organism** test(char* nameExp,int param=0);

/* Evaluation functions: */
bool xor_evaluate(Organism* org);
bool pole1_evaluate(Organism* org);
//Run input for pole1:
int go_cart(Organism* org,int max_steps);
//Move the cart and pole:
void cart_pole(int action, float* x,float* x_dot, float* theta, float* theta_dot);
// pig's evaluation; it's a "solution" if it kills all the enemies
bool pig_evaluate(Organism* org);
// fighter's evaluation: can just be relative, so we run a fight against best_fit;
// at the end: the_best==best_fit 
bool fight_evaluate(Organism* org);

// generic epoch function
int epoch(Population* pop,char* nameExp,int& winnergenes,int& winnernodes,double epoch_time);

#endif
