#include "FightInputs.h"

int* FightInputs::tabWidthActs_down;
int* FightInputs::tabWidthActs;
int* FightInputs::tabWidthActs_air;
int* FightInputs::tabHeightActs_down;
int* FightInputs::tabHeightActs;
int* FightInputs::tabHeightActs_air;
int* FightInputs::distX;
bool FightInputs::FALSE;
vector<Action> FightInputs::emptyVector;

// actions' history of the game (challenger: 1, player: 2):
Action* lastChallengerActions;
Action* lastPlayerActions;
bool *justHit1,*justHit2; // tells if the next move has just been effective
int curFrame; // current frame; useful at the beginning
int curFrameIndex; // current index in the vector of human actions
Control p1_ctrl1,p1_ctrl2,p2_ctrl1,p2_ctrl2; // controls for each organism
const int MAX_ACTION_MEMORY=2; // last actions in fighter's memory

// must be called before inputs treatment
void FightInputs::init_inputs() {
	lastChallengerActions=(Action*)calloc(MAX_ACTION_MEMORY,sizeof(Action));
	lastPlayerActions=(Action*)calloc(MAX_ACTION_MEMORY,sizeof(Action));
	justHit1=(bool*)calloc(17,sizeof(bool));
	justHit2=(bool*)calloc(17,sizeof(bool));
	curFrame=0;
	curFrameIndex=0;
	FALSE=false;

	tabWidthActs_down=(int*)malloc(17*sizeof(int));
	for (int i=8; i>=0; i--) tabWidthActs_down[i]=196;
	tabWidthActs_down[9]=178;
	tabWidthActs_down[10]=275;
	tabWidthActs_down[11]=182;
	tabWidthActs_down[12]=271;
	tabWidthActs_down[13]=295;
	tabWidthActs_down[14]=310;
	tabWidthActs_down[15]=249;
	tabWidthActs_down[16]=230;
	tabWidthActs=(int*)malloc(17*sizeof(int));
	for (int i=5; i>=0; i--) tabWidthActs[i]=142;
	for (int i=8; i>=6; i--) tabWidthActs[i]=196;
	tabWidthActs[9]=158;
	tabWidthActs[10]=286;
	tabWidthActs[11]=245;
	tabWidthActs[12]=287;
	tabWidthActs[13]=284;
	tabWidthActs[14]=310;
	tabWidthActs[15]=249;
	tabWidthActs[16]=230;
	tabWidthActs_air=(int*)malloc(17*sizeof(int));
	for (int i=5; i>=0; i--) tabWidthActs_air[i]=118;
	for (int i=8; i>=6; i--) tabWidthActs_air[i]=196;
	tabWidthActs_air[9]=118;
	tabWidthActs_air[10]=272;
	tabWidthActs_air[11]=261;
	for (int i=15; i>=12; i--) tabWidthActs_air[i]=309;
	tabWidthActs_air[16]=230;

	tabHeightActs_down=(int*)malloc(17*sizeof(int));
	for (int i=8; i>=0; i--) tabHeightActs_down[i]=251;
	tabHeightActs_down[9]=274;
	tabHeightActs_down[10]=281;
	tabHeightActs_down[11]=427;
	tabHeightActs_down[12]=231;
	tabHeightActs_down[13]=312;
	tabHeightActs_down[14]=163;
	tabHeightActs_down[15]=395;
	tabHeightActs_down[16]=404;
	tabHeightActs=(int*)malloc(17*sizeof(int));
	for (int i=5; i>=0; i--) tabHeightActs[i]=380;
	for (int i=8; i>=6; i--) tabHeightActs[i]=251;
	tabHeightActs[9]=397;
	tabHeightActs[10]=358;
	tabHeightActs[11]=376;
	tabHeightActs[12]=407;
	tabHeightActs[13]=367;
	tabHeightActs[14]=163;
	tabHeightActs[15]=395;
	tabHeightActs[16]=404;
	tabHeightActs_air=(int*)malloc(17*sizeof(int));
	for (int i=5; i>=0; i--) tabHeightActs_air[i]=391;
	for (int i=8; i>=6; i--) tabHeightActs_air[i]=251;
	tabHeightActs_air[9]=391;
	tabHeightActs_air[10]=222;
	tabHeightActs_air[11]=291;
	for (int i=15; i>=12; i--) tabHeightActs_air[i]=320;
	tabHeightActs_air[16]=404;
	
	distX=(int*)malloc(51*sizeof(int)); // distances from left side to front of player
	for (int i=8; i>=0; i--) distX[i]=160;
	distX[9]=147;
	distX[10]=204;
	distX[11]=162;
	distX[12]=137;
	distX[13]=157;
	distX[14]=143;
	distX[15]=95;
	distX[16]=171;
	for (int i=22; i>=17; i--) distX[i]=100;
	for (int i=25; i>=23; i--) distX[i]=160;
	distX[26]=115;
	distX[27]=167;
	distX[28]=148;
	distX[29]=87;
	distX[30]=118;
	distX[31]=143;
	distX[32]=95;
	distX[33]=171;
	for (int i=39; i>=34; i--) distX[i]=118;
	for (int i=42; i>=40; i--) distX[i]=160;
	distX[43]=118;
	distX[44]=235;
	distX[45]=191;
	distX[46]=137;
	distX[47]=137;
	distX[48]=137;
	distX[49]=137;
	distX[50]=171;
}

// get networks most active outputs:
void FightInputs::get_controls(Uint8* keys,Organism* org1,Organism* org2,int diffPosX_2_1,int diffPosY_2_1,
			Control& p1ct1,Control& p1ct2,Control& p2ct1,Control& p2ct2) {
	double* inputs=(double*)calloc(2+MAX_ACTION_MEMORY*17,sizeof(double));
	list<Neuron*>::iterator curnode;
	list<IncomingLink*>::iterator curlink;

	if (org1!=0) {
		// first, activate the network, based on the respective positions and
		// respective actions' history (last 2 actions of each fighter)
		inputs[0]=abs(diffPosX_2_1);
		inputs[1]=diffPosY_2_1;
		for (int i=MAX_ACTION_MEMORY-1; i>=0; i--) inputs[2+i*17+lastPlayerActions[i]]=1.0;
		org1->load_sensors(inputs);
		for (int i=org1->hidden_nodes.size(); i>=0; i--) org1->activate();

		// we look at the two max outputs;
		// if combination exists, we play it,
		// otherwise we play the most active output.
		double max1=-1.0,max2=-1.0;
		int curInd=0;
		p1ct1=NOTHING;
		p1ct2=NOTHING;
		for (curnode=org1->outputs.begin(); curnode!=org1->outputs.end(); curnode++) {
			if ((*curnode)->activation>max1 && (*curnode)->activation>=ACTIVATION_THRESHOLD) {
				max2=max1;
				max1=(*curnode)->activation;
				p1ct2=p1ct1;
				p1ct1=curInd;
			}
			else if ((*curnode)->activation>max2 && (*curnode)->activation>=ACTIVATION_THRESHOLD) {
				max2=(*curnode)->activation;
				p1ct2=curInd;
			}
			curInd++;
		}
/* SEEMS BAD IDEA :
		// increase all weights if outputs lack activation:
		if (p1ct1<0 || p2ct2<0) {
			for (curnode=org1->outputs.begin(); curnode!=org1->outputs.end(); curnode++) {
				for (curlink=(*curnode)->incoming.begin(); curlink!=(*curnode)->incoming.end(); curlink++)
					(*curlink)->weight += (fabs((*curlink)->weight)+MIN_LEARNING);
			}
			for (curnode=org1->hidden_nodes.begin(); curnode!=org1->hidden_nodes.end(); curnode++) {
				for (curlink=(*curnode)->incoming.begin(); curlink!=(*curnode)->incoming.end(); curlink++)
					(*curlink)->weight += (fabs((*curlink)->weight)+MIN_LEARNING);
			}
		}
*/
	}
	else {
		// human input: we just look at the pressed keys.
		p1ct1=NOTHING;
		p1ct2=NOTHING;
		int count=0;
		if (keys[SDLK_LEFT]) {
			if (count==0) p1ct1=LEFT;
			else p1ct2=LEFT;
			count++;
		}
		if (keys[SDLK_RIGHT]) {
			if (count==0) p1ct1=RIGHT;
			else p1ct2=RIGHT;
			count++;
		}
		if (keys[SDLK_UP]) {
			if (count==0) p1ct1=UP;
			else p1ct2=UP;
			count++;
		}
		if (keys[SDLK_DOWN]) {
			if (count==0) p1ct1=DOWN;
			else p1ct2=DOWN;
			count++;
		}
		if (keys[SDLK_0]) {
			if (count==0) p1ct1=ZERO;
			else p1ct2=ZERO;
			count++;
		}
		if (keys[SDLK_1]) {
			if (count==0) p1ct1=ONE;
			else p1ct2=ONE;
			count++;
		}
		if (keys[SDLK_5]) {
			if (count==0) p1ct1=FIVE;
			else p1ct2=FIVE;
			count++;
		}
		if (keys[SDLK_2]) {
			if (count==0) p1ct1=TWO;
			else p1ct2=TWO;
			count++;
		}
		if (keys[SDLK_6]) {
			if (count==0) p1ct1=SIX;
			else p1ct2=SIX;
			count++;
		}
	}

	// then, org2: neural network, or human memory:
	if (org2!=0) {
		// first, activate the network, based on the respective positions and
		// respective actions' history (last 2 actions of each fighter)
		inputs[0]=abs(diffPosX_2_1);
		inputs[1]=-diffPosY_2_1;
		for (int i=MAX_ACTION_MEMORY-1; i>=0; i--) inputs[2+i*17+lastPlayerActions[i]]=0.0;
		for (int i=MAX_ACTION_MEMORY-1; i>=0; i--) inputs[2+i*17+lastChallengerActions[i]]=1.0;
		org2->load_sensors(inputs);
		for (int i=org2->hidden_nodes.size(); i>=0; i--) org2->activate();

		// we look at the two max outputs;
		// if combination exists, we play it,
		// otherwise we play the most active output.
		double max1=-1.0,max2=-1.0;
		int curInd=0;
		p2ct1=NOTHING;
		p2ct2=NOTHING;
		for (curnode=org2->outputs.begin(); curnode!=org2->outputs.end(); curnode++) {
			if ((*curnode)->activation>max1 && (*curnode)->activation>=ACTIVATION_THRESHOLD) {
				max2=max1;
				max1=(*curnode)->activation;
				p2ct2=p2ct1;
				p2ct1=curInd;
			}
			else if ((*curnode)->activation>max2 && (*curnode)->activation>=ACTIVATION_THRESHOLD) {
				max2=(*curnode)->activation;
				p2ct2=curInd;
			}
			curInd++;
		}
/* SEEMS BAD IDEA :
		// increase all weights if outputs lack activation:
		if (p1ct1<0 || p2ct2<0) {
			for (curnode=org2->outputs.begin(); curnode!=org2->outputs.end(); curnode++) {
				for (curlink=(*curnode)->incoming.begin(); curlink!=(*curnode)->incoming.end(); curlink++)
					(*curlink)->weight += (fabs((*curlink)->weight)+MIN_LEARNING);
			}
			for (curnode=org2->hidden_nodes.begin(); curnode!=org2->hidden_nodes.end(); curnode++) {
				for (curlink=(*curnode)->incoming.begin(); curlink!=(*curnode)->incoming.end(); curlink++)
					(*curlink)->weight += (fabs((*curlink)->weight)+MIN_LEARNING);
			}
		}
*/
	}

	p1_ctrl1=p1ct1;
	p1_ctrl2=p1ct2;
	p2_ctrl1=p2ct1;
	p2_ctrl2=p2ct2;
}

// function to manage input keys
ActionsAndPositions FightInputs::inputs_handler(Organism* org1,Organism* org2,double& life1,SDL_Rect& position1,double& life2,
			SDL_Rect& position2,bool& downPressed1,bool& downPressed2,vector<Action>& humanActions) {
	Action nextAction1,nextAction2; // next actions of each fighter
	ActionsAndPositions actsAndPos; // result of the function: next actions and old positions
	actsAndPos.r1=position1;
	actsAndPos.r2=position2;

	bool leftRight=(position1.x+distX[17*(position1.y<GROUND ? 2 : (position1.y==GROUND ? 1 : 0))+lastChallengerActions[MAX_ACTION_MEMORY-1]]
		<= position2.x+position2.w-distX[17*(position2.y<GROUND ? 2 : (position2.y==GROUND ? 1 : 0))+lastPlayerActions[MAX_ACTION_MEMORY-1]]+EPSILON+7);

	if (org1!=0) {
		if (p1_ctrl1==DOWN || p1_ctrl2==DOWN) downPressed1=true;
		nextAction1=UNDEFINED;
		switch (p1_ctrl1) {
			case LEFT:
				switch (p1_ctrl2) {
					case UP:
						nextAction1=DIR_UP_LEFT;
						break;
					case DOWN:
						nextAction1=DIR_DOWN_LEFT;
						break;
					case ONE:
						position1.x=maxm(position1.x-STEP,0);
						nextAction1=PUNCH1;
						break;
					case FIVE:
						position1.x=maxm(position1.x-STEP,0);
						nextAction1=PUNCH2;
						break;
					case TWO:
						if (position1.x<position2.x) nextAction1=REVERSE_KICK1;
						else {
							position1.x=maxm(position1.x-STEP,0);
							nextAction1=KNEE_HIT;
						}
						break;
					case SIX:
						if (position1.x<position2.x) nextAction1=REVERSE_KICK2;
						else {
							position1.x=maxm(position1.x-STEP,0);
							nextAction1=KICK2;
						}
						break;
					default:
						break;
				}
				break;
			case RIGHT:
				switch (p1_ctrl2) {
					case UP:
						nextAction1=DIR_UP_RIGHT;
						break;
					case DOWN:
						nextAction1=DIR_DOWN_RIGHT;
						break;
					case ONE:
						position1.x=minm(position1.x+STEP,SCREEN_W-punch1W);
						nextAction1=PUNCH1;
						break;
					case FIVE:
						position1.x=minm(position1.x+STEP,SCREEN_W-punch2W);
						nextAction1=PUNCH2;
						break;
					case TWO:
						if (position1.x>position2.x) nextAction1=REVERSE_KICK1;
						else {
							position1.x=minm(position1.x+STEP,SCREEN_W-kneeW);
							nextAction1=KNEE_HIT;
						}
						break;
					case SIX:
						if (position1.x>position2.x) nextAction1=REVERSE_KICK2;
						else {
							position1.x=minm(position1.x+STEP,SCREEN_W-kick2W);
							nextAction1=KICK2;
						}
						break;
					default:
						break;
				}
				break;
			case UP:
				switch (p1_ctrl2) {
					case LEFT:
						nextAction1=DIR_UP_LEFT;
						break;
					case RIGHT:
						nextAction1=DIR_UP_RIGHT;
						break;
					default:
						break;
				}
				break;
			case DOWN:
				switch (p1_ctrl2) {
					case LEFT:
						nextAction1=DIR_DOWN_LEFT;
						break;
					case RIGHT:
						nextAction1=DIR_DOWN_RIGHT;
						break;
					case ZERO:
						nextAction1=GUARD;
						break;
					case ONE:
						nextAction1=PUNCH1;
						break;
					case FIVE:
						nextAction1=PUNCH2;
						break;
					case TWO:
						nextAction1=KICK1;
						break;
					case SIX:
						nextAction1=KICK2;
						break;
					default:
						break;
				}
				break;
			case ZERO:
				nextAction1=GUARD;
				break;
			case ONE:
				nextAction1=PUNCH1;
				break;
			case FIVE:
				nextAction1=PUNCH2;
				break;
			case TWO:
				switch (p1_ctrl2) {
					case LEFT:
						if (position1.x<position2.x) nextAction1=REVERSE_KICK1;
						else {
							position1.x=maxm(position1.x-STEP,0);
							nextAction1=KNEE_HIT;
						}
						break;
					case RIGHT:
						if (position1.x>position2.x) nextAction1=REVERSE_KICK1;
						else {
							position1.x=minm(position1.x+STEP,SCREEN_W-kneeW);
							nextAction1=KNEE_HIT;
						}
						break;
					default:
						break;
				}
				break;
			case SIX:
				switch (p1_ctrl2) {
					case LEFT:
						if (position1.x<position2.x) nextAction1=REVERSE_KICK2;
						else {
							position1.x=maxm(position1.x-STEP,0);
							nextAction1=KICK2;
						}
						break;
					case RIGHT:
						if (position1.x>position2.x) nextAction1=REVERSE_KICK2;
						else {
							position1.x=minm(position1.x+STEP,SCREEN_W-kick2W);
							nextAction1=KICK2;
						}
						break;
					default:
						break;
				}
				break;
			default:
				break;
		}
		if (nextAction1==UNDEFINED) {
			switch (p1_ctrl1) {
				case LEFT:
					nextAction1=DIR_LEFT;
					break;
				case RIGHT:
					nextAction1=DIR_RIGHT;
					break;
				case UP:
					nextAction1=DIR_UP;
					break;
				case DOWN:
					nextAction1=DIR_DOWN;
					break;
				case TWO:
					nextAction1=KICK1;
					break;
				case SIX:
					nextAction1=KICK2;
					break;
				default:
					break;
			}
		}
	}
	else {
		// human input
		downPressed1=(p1_ctrl1==DOWN || p1_ctrl2==DOWN);
		nextAction1=UNDEFINED;
		switch (p1_ctrl1) {
			case LEFT:
				switch (p1_ctrl2) {
					case UP:
						nextAction1=DIR_UP_LEFT;
						break;
					case DOWN:
						nextAction1=DIR_DOWN_LEFT;
						break;
					case ONE:
						position1.x=maxm(position1.x-STEP,0);
						nextAction1=PUNCH1;
						break;
					case FIVE:
						position1.x=maxm(position1.x-STEP,0);
						nextAction1=PUNCH2;
						break;
					case TWO:
						if (position1.x<position2.x) nextAction1=REVERSE_KICK1;
						else {
							position1.x=maxm(position1.x-STEP,0);
							nextAction1=KNEE_HIT;
						}
						break;
					case SIX:
						if (position1.x<position2.x) nextAction1=REVERSE_KICK2;
						else {
							position1.x=maxm(position1.x-STEP,0);
							nextAction1=KICK2;
						}
						break;
					default:
						break;
				}
				break;
			case RIGHT:
				switch (p1_ctrl2) {
					case UP:
						nextAction1=DIR_UP_RIGHT;
						break;
					case DOWN:
						nextAction1=DIR_DOWN_RIGHT;
						break;
					case ONE:
						position1.x=minm(position1.x+STEP,SCREEN_W-punch1W);
						nextAction1=PUNCH1;
						break;
					case FIVE:
						position1.x=minm(position1.x+STEP,SCREEN_W-punch2W);
						nextAction1=PUNCH2;
						break;
					case TWO:
						if (position1.x>position2.x) nextAction1=REVERSE_KICK1;
						else {
							position1.x=minm(position1.x+STEP,SCREEN_W-kneeW);
							nextAction1=KNEE_HIT;
						}
						break;
					case SIX:
						if (position1.x>position2.x) nextAction1=REVERSE_KICK2;
						else {
							position1.x=minm(position1.x+STEP,SCREEN_W-kick2W);
							nextAction1=KICK2;
						}
						break;
					default:
						break;
				}
				break;
			case UP:
				switch (p1_ctrl2) {
					case LEFT:
						nextAction1=DIR_UP_LEFT;
						break;
					case RIGHT:
						nextAction1=DIR_UP_RIGHT;
						break;
					default:
						break;
				}
				break;
			case DOWN:
				switch (p1_ctrl2) {
					case LEFT:
						nextAction1=DIR_DOWN_LEFT;
						break;
					case RIGHT:
						nextAction1=DIR_DOWN_RIGHT;
						break;
					case ZERO:
						nextAction1=GUARD;
						break;
					case ONE:
						nextAction1=PUNCH1;
						break;
					case FIVE:
						nextAction1=PUNCH2;
						break;
					case TWO:
						nextAction1=KICK1;
						break;
					case SIX:
						nextAction1=KICK2;
						break;
					default:
						break;
				}
				break;
			case ZERO:
				nextAction1=GUARD;
				break;
			case ONE:
				nextAction1=PUNCH1;
				break;
			case FIVE:
				nextAction1=PUNCH2;
				break;
			case TWO:
				switch (p1_ctrl2) {
					case LEFT:
						if (position1.x<position2.x) nextAction1=REVERSE_KICK1;
						else {
							position1.x=maxm(position1.x-STEP,0);
							nextAction1=KNEE_HIT;
						}
						break;
					case RIGHT:
						if (position1.x>position2.x) nextAction1=REVERSE_KICK1;
						else {
							position1.x=minm(position1.x+STEP,SCREEN_W-kneeW);
							nextAction1=KNEE_HIT;
						}
						break;
					default:
						break;
				}
				break;
			case SIX:
				switch (p1_ctrl2) {
					case LEFT:
						if (position1.x<position2.x) nextAction1=REVERSE_KICK2;
						else {
								position1.x=maxm(position1.x-STEP,0);
							nextAction1=KICK2;
						}
						break;
					case RIGHT:
						if (position1.x>position2.x) nextAction1=REVERSE_KICK2;
						else {
							position1.x=minm(position1.x+STEP,SCREEN_W-kick2W);
							nextAction1=KICK2;
						}
						break;
					default:
						break;
				}
				break;
			default:
				break;
		}
		if (nextAction1==UNDEFINED) {
			switch (p1_ctrl1) {
				case LEFT:
					nextAction1=DIR_LEFT;
					break;
				case RIGHT:
					nextAction1=DIR_RIGHT;
					break;
				case UP:
					nextAction1=DIR_UP;
					break;
				case DOWN:
					nextAction1=DIR_DOWN;
					break;
				case TWO:
					nextAction1=KICK1;
					break;
				case SIX:
					nextAction1=KICK2;
					break;
				default:
					break;
			}
		}
	}

	// then, org2: neural network, or human memory:
	if (org2!=0) {
		if (p2_ctrl1==DOWN || p2_ctrl2==DOWN) downPressed2=true;
		nextAction2=UNDEFINED;
		switch (p2_ctrl1) {
			case LEFT:
				switch (p2_ctrl2) {
					case UP:
						nextAction2=DIR_UP_LEFT;
						break;
					case DOWN:
						nextAction2=DIR_DOWN_LEFT;
						break;
					case ONE:
						position2.x=maxm(position2.x-STEP,0);
						nextAction2=PUNCH1;
						break;
					case FIVE:
						position2.x=maxm(position2.x-STEP,0);
						nextAction2=PUNCH2;
						break;
					case TWO:
						if (position2.x<position1.x) nextAction2=REVERSE_KICK1;
						else {
							position2.x=maxm(position2.x-STEP,0);
							nextAction2=KNEE_HIT;
						}
						break;
					case SIX:
						if (position2.x<position1.x) nextAction2=REVERSE_KICK2;
						else {
							position2.x=maxm(position2.x-STEP,0);
							nextAction2=KICK2;
						}
						break;
					default:
						break;
				}
				break;
			case RIGHT:
				switch (p2_ctrl2) {
					case UP:
						nextAction2=DIR_UP_RIGHT;
						break;
					case DOWN:
						nextAction2=DIR_DOWN_RIGHT;
						break;
					case ONE:
						position2.x=minm(position2.x+STEP,SCREEN_W-punch1W);
						nextAction2=PUNCH1;
						break;
					case FIVE:
						position2.x=minm(position2.x+STEP,SCREEN_W-punch2W);
						nextAction2=PUNCH2;
						break;
					case TWO:
						if (position2.x>position1.x) nextAction2=REVERSE_KICK1;
						else {
							position2.x=minm(position2.x+STEP,SCREEN_W-kneeW);
							nextAction2=KNEE_HIT;
						}
						break;
					case SIX:
						if (position2.x>position1.x) nextAction2=REVERSE_KICK2;
						else {
							position2.x=minm(position2.x+STEP,SCREEN_W-kick2W);
							nextAction2=KICK2;
						}
						break;
					default:
						break;
				}
				break;
			case UP:
				switch (p2_ctrl2) {
					case LEFT:
						nextAction2=DIR_UP_LEFT;
						break;
					case RIGHT:
						nextAction2=DIR_UP_RIGHT;
						break;
					default:
						break;
				}
				break;
			case DOWN:
				switch (p2_ctrl2) {
					case LEFT:
						nextAction2=DIR_DOWN_LEFT;
						break;
					case RIGHT:
						nextAction2=DIR_DOWN_RIGHT;
						break;
					case ZERO:
						nextAction2=GUARD;
						break;
					case ONE:
						nextAction2=PUNCH1;
						break;
					case FIVE:
						nextAction2=PUNCH2;
						break;
					case TWO:
						nextAction2=KICK1;
						break;
					case SIX:
						nextAction2=KICK2;
						break;
					default:
						break;
				}
				break;
			case ZERO:
				nextAction2=GUARD;
				break;
			case ONE:
				nextAction2=PUNCH1;
				break;
			case FIVE:
				nextAction2=PUNCH2;
				break;
			case TWO:
				switch (p2_ctrl2) {
					case LEFT:
						if (position2.x<position1.x) nextAction2=REVERSE_KICK1;
						else {
							position2.x=maxm(position2.x-STEP,0);
							nextAction2=KNEE_HIT;
						}
						break;
					case RIGHT:
						if (position2.x>position1.x) nextAction2=REVERSE_KICK1;
						else {
							position2.x=minm(position2.x+STEP,SCREEN_W-kneeW);
							nextAction2=KNEE_HIT;
						}
						break;
					default:
						break;
				}
				break;
			case SIX:
				switch (p2_ctrl2) {
					case LEFT:
						if (position2.x<position1.x) nextAction2=REVERSE_KICK2;
						else {
							position2.x=maxm(position2.x-STEP,0);
							nextAction2=KICK2;
						}
						break;
					case RIGHT:
						if (position2.x>position1.x) nextAction2=REVERSE_KICK2;
						else {
							position2.x=minm(position2.x+STEP,SCREEN_W-kick2W);
							nextAction2=KICK2;
						}
						break;
					default:
						break;
				}
				break;
			default:
				break;
		}
		if (nextAction2==UNDEFINED) {
			switch (p2_ctrl1) {
				case LEFT:
					nextAction2=DIR_LEFT;
					break;
				case RIGHT:
					nextAction2=DIR_RIGHT;
					break;
				case UP:
					nextAction2=DIR_UP;
					break;
				case DOWN:
					nextAction2=DIR_DOWN;
					break;
				case TWO:
					nextAction2=KICK1;
					break;
				case SIX:
					nextAction2=KICK2;
					break;
				default:
					break;
			}
		}
	}
	else {
		if (curFrameIndex>=(int)humanActions.size()) curFrameIndex=0;
		nextAction2=humanActions[curFrameIndex++];
	}

	for (int i=0; i<curFrame; i++) {
		lastChallengerActions[i]=lastChallengerActions[i+1];
		lastPlayerActions[i]=lastPlayerActions[i+1];
	}
	lastChallengerActions[curFrame]=nextAction1;
	lastPlayerActions[curFrame]=nextAction2;

	// finally, just do the actions (could be undefined!!), and give values for changed life/positions;
	// first handle moves if there are:
	bool lvlCh1=false;
	if (!downPressed1 && position1.y>GROUND) {
		position1.y=GROUND;
		lvlCh1=true;
	}
	bool guard1=false,downGuard1=false,jumped1=false;
	switch (nextAction1) {
		case DIR_LEFT:
			if (position1.y>=GROUND) position1.x=maxm(position1.x-STEP,0);
			else position1.x=maxm(position1.x-STEP,0);
			break;
		case DIR_RIGHT:
			if (position1.y>GROUND) position1.x=minm(position1.x+STEP,SCREEN_W-downW);
			else if (position1.y==GROUND) position1.x=minm(position1.x+STEP,SCREEN_W-waitingW);
			else position1.x=minm(position1.x+STEP,SCREEN_W-jumpW);
			break;
		case DIR_UP:
			if (position1.y>=GROUND) {
				jumped1=true;
				lvlCh1=true;
				position1.y-=FULL_JUMP;
			}
			break;
		case DIR_UP_LEFT:
			if (position1.y>=GROUND) {
				jumped1=true;
				lvlCh1=true;
				position1.x=maxm(position1.x-STEP,0);
				position1.y-=FULL_JUMP;
			}
			else position1.x=maxm(position1.x-STEP,0);
			break;
		case DIR_UP_RIGHT:
			if (position1.y>GROUND) {
				jumped1=true;
				lvlCh1=true;
				position1.x=minm(position1.x+STEP,SCREEN_W-downW);
				position1.y-=FULL_JUMP;
			}
			else if (position1.y==GROUND) {
				jumped1=true;
				lvlCh1=true;
				position1.x=minm(position1.x+STEP,SCREEN_W-waitingW);
				position1.y-=FULL_JUMP;
			}
			else position1.x=minm(position1.x+STEP,SCREEN_W-jumpW);
			break;
		case DIR_DOWN:
			if (position1.y==GROUND) {
				position1.y+=STEP_DOWN;
				lvlCh1=true;
			}
			break;
		case DIR_DOWN_LEFT:
			if (position1.y==GROUND) {
				position1.y+=STEP_DOWN;
				lvlCh1=true;
			}
			position1.x=maxm(position1.x-STEP,0);
			break;
		case DIR_DOWN_RIGHT:
			if (position1.y==GROUND) {
				position1.y+=STEP_DOWN;
				lvlCh1=true;
			}
			position1.x=minm(position1.x+STEP,SCREEN_W-downW);
			break;
		case GUARD:
			if (position1.y>GROUND) downGuard1=true;
			else if (position1.y==GROUND) guard1=true;
			break;
		default:
			break;
	}
	// same job for player 2:
	bool lvlCh2=false;
	if (!downPressed2 && position2.y>GROUND) {
		position2.y=GROUND;
		lvlCh2=true;
	}
	bool guard2=false,downGuard2=false,jumped2=false;
	switch (nextAction2) {
		case DIR_LEFT:
			if (position2.y>=GROUND) position2.x=maxm(position2.x-STEP,0);
			else position2.x=maxm(position2.x-STEP,0);
			break;
		case DIR_RIGHT:
			if (position2.y>GROUND) position2.x=minm(position2.x+STEP,SCREEN_W-downW);
			else if (position2.y==GROUND) position2.x=minm(position2.x+STEP,SCREEN_W-waitingW);
			else position2.x=minm(position2.x+STEP,SCREEN_W-jumpW);
			break;
		case DIR_UP:
			if (position2.y>=GROUND) {
				jumped2=true;
				lvlCh2=true;
				position2.y-=FULL_JUMP;
			}
			break;
		case DIR_UP_LEFT:
			if (position2.y>=GROUND) {
				jumped2=true;
				lvlCh2=true;
				position2.x=maxm(position2.x-STEP,0);
				position2.y-=FULL_JUMP;
			}
			else position2.x=maxm(position2.x-STEP,0);
			break;
		case DIR_UP_RIGHT:
			if (position2.y>GROUND) {
				jumped2=true;
				lvlCh2=true;
				position2.x=minm(position2.x+STEP,SCREEN_W-downW);
				position2.y-=FULL_JUMP;
			}
			else if (position2.y==GROUND) {
				jumped2=true;
				lvlCh2=true;
				position2.x=minm(position2.x+STEP,SCREEN_W-waitingW);
				position2.y-=FULL_JUMP;
			}
			else position2.x=minm(position2.x+STEP,SCREEN_W-jumpW);
			break;
		case DIR_DOWN:
			if (position2.y==GROUND) {
				position2.y+=STEP_DOWN;
				lvlCh2=true;
			}
			break;
		case DIR_DOWN_LEFT:
			if (position2.y==GROUND) {
				position2.y+=STEP_DOWN;
				lvlCh2=true;
			}
			position2.x=maxm(position2.x-STEP,0);
			break;
		case DIR_DOWN_RIGHT:
			if (position2.y==GROUND) {
				position2.y+=STEP_DOWN;
				lvlCh2=true;
			}
			position2.x=minm(position2.x+STEP,SCREEN_W-downW);
			break;
		case GUARD:
			if (position2.y>GROUND) downGuard2=true;
			else if (position2.y==GROUND) guard2=true;
			break;
		default:
			break;
	}

	// just come back to earth if in the air:
	if (position1.y<GROUND && !jumped1) {
		position1.y+=FTH_JUMP;
		if (position1.y==GROUND) {
			position1.w=waitingW;
			position1.h=waitingH;
		}
		lvlCh1=true;
	}
	if (position2.y<GROUND && !jumped2) {
		position2.y+=FTH_JUMP;
		if (position2.y==GROUND) {
			position2.w=waitingW;
			position2.h=waitingH;
		}
		lvlCh2=true;
	}
	actsAndPos.lvC1=lvlCh1;
	actsAndPos.lvC2=lvlCh2;
	bool inTheAir1=(position1.y<GROUND),
		onTheGround1=(position1.y==GROUND),
		inTheAir2=(position2.y<GROUND),
		onTheGround2=(position2.y==GROUND);

	int hShift1=0,hShift2=0,vShift1=0,vShift2=0;
	if (leftRight) {
		// player 1:
		if (position1.y>=GROUND) {
			if (downPressed1) {
				position1.y=GROUND+STEP_DOWN+tabHeightActs_down[0]-tabHeightActs_down[nextAction1];
				position1.w=tabWidthActs_down[nextAction1];
				position1.h=tabHeightActs_down[nextAction1];
			}
			else {
				position1.y=GROUND+tabHeightActs[0]-tabHeightActs[nextAction1];
				position1.w=tabWidthActs[nextAction1];
				position1.h=tabHeightActs[nextAction1];
			}
		}
		else {
			if (!lvlCh1) vShift1=tabHeightActs_air[nextAction1]-position1.h;
			position1.w=tabWidthActs_air[nextAction1];
			position1.h=tabHeightActs_air[nextAction1];
			position1.y-=vShift1;
		}
		// player 2:
		if (position2.y>=GROUND) {
			if (downPressed2) {
				hShift2=maxm(tabWidthActs_down[nextAction2]-position2.w,0);
				position2.y=GROUND+STEP_DOWN+tabHeightActs_down[0]-tabHeightActs_down[nextAction2];
				position2.w=tabWidthActs_down[nextAction2];
				position2.h=tabHeightActs_down[nextAction2];
			}
			else {
				hShift2=maxm(tabWidthActs[nextAction2]-position2.w,0);
				position2.y=GROUND+tabHeightActs[0]-tabHeightActs[nextAction2];
				position2.w=tabWidthActs[nextAction2];
				position2.h=tabHeightActs[nextAction2];
			}
		}
		else {
			hShift2=maxm(tabWidthActs_air[nextAction2]-position2.w,0);
			if (!lvlCh2) vShift2=tabHeightActs_air[nextAction2]-position2.h;
			position2.w=tabWidthActs_air[nextAction2];
			position2.h=tabHeightActs_air[nextAction2];
			position2.y-=vShift2;
		}
		position2.x-=hShift2;
	}
	else {
		// player 1:
		if (position1.y>=GROUND) {
			if (downPressed1) {
				hShift1=maxm(tabWidthActs_down[nextAction1]-position1.w,0);
				position1.y=GROUND+STEP_DOWN+tabHeightActs_down[0]-tabHeightActs_down[nextAction1];
				position1.w=tabWidthActs_down[nextAction1];
				position1.h=tabHeightActs_down[nextAction1];
			}
			else {
				hShift1=maxm(tabWidthActs[nextAction1]-position1.w,0);
				position1.y=GROUND+tabHeightActs[0]-tabHeightActs[nextAction1];
				position1.w=tabWidthActs[nextAction1];
				position1.h=tabHeightActs[nextAction1];
			}
		}
		else {
			hShift1=maxm(tabWidthActs_air[nextAction1]-position1.w,0);
			if (!lvlCh1) vShift1=tabHeightActs_air[nextAction1]-position1.h;
			position1.w=tabWidthActs_air[nextAction1];
			position1.h=tabHeightActs_air[nextAction1];
			position1.y-=vShift1;
		}
		position1.x-=hShift1;
		// player 2:
		if (position2.y>=GROUND) {
			if (downPressed2) {
				position2.y=GROUND+STEP_DOWN+tabHeightActs_down[0]-tabHeightActs_down[nextAction2];
				position2.w=tabWidthActs_down[nextAction2];
				position2.h=tabHeightActs_down[nextAction2];
			}
			else {
				position2.y=GROUND+tabHeightActs[0]-tabHeightActs[nextAction2];
				position2.w=tabWidthActs[nextAction2];
				position2.h=tabHeightActs[nextAction2];
			}
		}
		else {
			if (!lvlCh2) vShift2=tabHeightActs_air[nextAction2]-position2.h;
			position2.w=tabWidthActs_air[nextAction2];
			position2.h=tabHeightActs_air[nextAction2];
			position2.y-=vShift2;
		}
	}

	// now look at hits:
	double memLife2=life2;
	int baseShift1;
	if (inTheAir1) baseShift1=2;
	else if (onTheGround1) baseShift1=1;
	else baseShift1=0;
	int baseShift2;
	if (inTheAir2) baseShift2=2;
	else if (onTheGround2) baseShift2=1;
	else baseShift2=0;
	bool distCondHit1=(position1.y+(position1.h)/2<position2.y+position2.h
					&& position1.y+(position1.h)/2>position2.y
					&& ((leftRight && position2.x+position2.w-distX[17*baseShift2+nextAction2]-position1.x-position1.w<=EPSILON)
						|| (!leftRight && position1.x-position2.x-distX[17*baseShift2+nextAction2]<=EPSILON)));
	bool distCondHit2=(position1.y+(position1.h)/2<position2.y+position2.h
					&& position1.y+(position1.h)/2>position2.y
					&& ((leftRight && position2.x-position1.x-distX[17*baseShift1+nextAction1]<=EPSILON)
						|| (!leftRight && position1.x+position1.w-distX[17*baseShift1+nextAction1]-position2.x-position2.w<=EPSILON)));

	if (!justHit1[lastChallengerActions[curFrame]] && distCondHit1) {
		// nothing happen if same hit as before, or distances are not OK for hits
		switch (nextAction1) {
			case PUNCH1:
				if (!downGuard2) {
					if (inTheAir1) {
						if (!guard2) life2-=A_PUNCH_DAMAGE;
					}
					else if (onTheGround1) {
						if (!guard2 && !downPressed2) life2-=PUNCH_DAMAGE;
					}
					else life2-=D_PUNCH1_DAMAGE;
				}
				break;
			case PUNCH2:
				if (!downGuard2 && !guard2) {
					if (inTheAir1) life2-=A_PUNCH_DAMAGE;
					else if (!downPressed2) {
						if (onTheGround1) life2-=PUNCH_DAMAGE;
						else life2-=D_PUNCH2_DAMAGE;
					}
				}
				break;
			case KICK1:
				if (!downGuard2 && !guard2) {
					if (inTheAir1) life2-=A_KICK_DAMAGE;
					else if (onTheGround1 && !downPressed2) life2-=KICK_DAMAGE;
				}
				if (downPressed1 && !inTheAir2) life2-=D_KICK1_DAMAGE;
				break;
			case KICK2:
				if (!downGuard2 && !guard2) {
					if (inTheAir1) life2-=A_KICK_DAMAGE;
					else if (onTheGround1) {
						if (!downPressed2) life2-=KICK_DAMAGE;
					}
					else life2-=D_KICK2_DAMAGE;
				}
				break;
			case REVERSE_KICK1:
				if (inTheAir1) {
					if (!guard2) life2-=A_KICK_DAMAGE;
				}
				else if (onTheGround1) life2-=REV_KICK_DAMAGE;
				break;
			case REVERSE_KICK2:
				if (!downGuard2 && !guard2) {
					if (inTheAir1) life2-=A_KICK_DAMAGE;
					else if (onTheGround1 && !downPressed2) life2-=REV_KICK_DAMAGE;
				}
				break;
			case KNEE_HIT:
				if (guard2 || downGuard2) life2-=KNEE_HIT_DAMAGE/2.0;
				else life2-=KNEE_HIT_DAMAGE;
				break;
			default:
				break;
		}
	}
	// and player 2:
	double memLife1=life1;
	if (!justHit2[lastPlayerActions[curFrame]] && distCondHit2) {
		// nothing happen if same hit as before, or distances are not OK for hits
		switch (nextAction2) {
			case PUNCH1:
				if (!downGuard1) {
					if (inTheAir2) {
						if (!guard1) life1-=A_PUNCH_DAMAGE;
					}
					else if (onTheGround2) {
						if (!guard1 && !downPressed1) life1-=PUNCH_DAMAGE;
					}
					else life1-=D_PUNCH1_DAMAGE;
				}
				break;
			case PUNCH2:
				if (!downGuard1 && !guard1) {
					if (inTheAir2) life1-=A_PUNCH_DAMAGE;
					else if (!downPressed1) {
						if (onTheGround2) life1-=PUNCH_DAMAGE;
						else life1-=D_PUNCH2_DAMAGE;
					}
				}
				break;
			case KICK1:
				if (!downGuard1 && !guard1) {
					if (inTheAir2) life1-=A_KICK_DAMAGE;
					else if (onTheGround2 && !downPressed1) life1-=KICK_DAMAGE;
				}
				if (downPressed2 && !inTheAir1) life1-=D_KICK1_DAMAGE;
				break;
			case KICK2:
				if (!downGuard1 && !guard1) {
					if (inTheAir2) life1-=A_KICK_DAMAGE;
					else if (onTheGround2) {
						if (!downPressed1) life1-=KICK_DAMAGE;
					}
					else life1-=D_KICK2_DAMAGE;
				}
				break;
			case REVERSE_KICK1:
				if (inTheAir2) {
					if (!guard1) life1-=A_KICK_DAMAGE;
				}
				else if (onTheGround2) life1-=REV_KICK_DAMAGE;
				break;
			case REVERSE_KICK2:
				if (!downGuard1 && !guard1) {
					if (inTheAir2) life1-=A_KICK_DAMAGE;
					else if (onTheGround2 && !downPressed1) life1-=REV_KICK_DAMAGE;
				}
				break;
			case KNEE_HIT:
				if (guard1 || downGuard1) life1-=KNEE_HIT_DAMAGE/2.0;
				else life1-=KNEE_HIT_DAMAGE;
				break;
			default:
				break;
		}
	}

	// not allow "ghost fighters" after hits:
	if (leftRight && position1.x+distX[17*baseShift1+nextAction1]
		> position2.x+position2.w-distX[17*baseShift2+nextAction2]
			&& (position1.y+position1.h>position2.y || position1.y+position1.h<position2.y+position2.h)) {
		int halfDelta=(int)ceil((double)(position1.x+distX[17*baseShift1+nextAction1]-position2.x-position2.w+distX[17*baseShift2+nextAction2])/2.0);
		int newPos1X=position1.x-halfDelta;
		position1.x=maxm(newPos1X,0);
		int newPos2X=position2.x+halfDelta;
		position2.x=minm(newPos2X,SCREEN_W-position2.w);
		if (newPos1X<0) position2.x-=newPos1X;
		else if (newPos2X>SCREEN_W-position2.w) position1.x-=(newPos2X-SCREEN_W+position2.w);
	}
	else if (!leftRight && position2.x+distX[17*baseShift2+nextAction2]
			>= position1.x+position1.w-distX[17*baseShift1+nextAction1]
				&& (position2.y+position2.h>position1.y || position2.y+position2.h<position1.y+position1.h)) {
		int halfDelta=(int)ceil((double)(position2.x+distX[17*baseShift2+nextAction2]-position1.x-position1.w+distX[17*baseShift1+nextAction1])/2.0);
		int newPos2X=position2.x-halfDelta;
		position2.x=maxm(newPos2X,0);
		int newPos1X=position1.x+halfDelta;
		position1.x=minm(newPos1X,SCREEN_W-position1.w);
		if (newPos2X<0) position1.x-=newPos2X;
		else if (newPos1X>SCREEN_W-position1.w) position2.x-=(newPos1X-SCREEN_W+position1.w);
	}

	// give back original logic coordinates:
	position1.x+=hShift1;
	if (inTheAir1) position1.y+=vShift1;
	else if (onTheGround1) position1.y=GROUND;
	else position1.y=GROUND+STEP_DOWN;
	position2.x+=hShift2;
	if (inTheAir2) position2.y+=vShift2;
	else if (onTheGround2) position2.y=GROUND;
	else position2.y=GROUND+STEP_DOWN;

	// reinit justHit and increment curFrame:
	for (int i=16; i>=0; i--) {
		justHit1[i]=false;
		justHit2[i]=false;
	}
	justHit1[lastChallengerActions[curFrame]]=(memLife2!=life2);
	justHit2[lastPlayerActions[curFrame]]=(memLife1!=life1);
	curFrame=minm(curFrame+1,MAX_ACTION_MEMORY-1);

	actsAndPos.act1=nextAction1;
	actsAndPos.act2=nextAction2;
	return actsAndPos;
}
