#ifndef _Fighter
#define _Fighter

#include <list>
#include <string>
#include <fstream>
#include <SDL/SDL.h>
#include <SDL/SDL_image.h>
#include "Neat.h"
#include "Neuron.h"
#include "Organism.h"
#include "Graphic.h"
#include "FightInputs.h"

using namespace std;

// test a fighter "challenger", against the best organism ever found
// NOTE: this form of testing allows learning during evaluation !

class Fighter {

public:

	Fighter () {}

	~Fighter () {}

	// must be called before any fight:
	static void init_fight();
	
	// function to add an incoming link without redondancy to a list: we compare the adresses of objects
	static void insertWR(IncomingLink* link,list<IncomingLink*>& incList);
	
	// fighter learning: increase or decrease connections between active inputs and outputs
	static void learnWeights(Organism* org,Control ctrl,list<list<Neuron*> >& layers,bool increase);
	
	// fighter's evaluation: can just be relative, so we run a fight against best_fit
	static void launch_test_fight(Organism* org,Organism* best_fit_org);
	
	static bool should_exit(SDL_Event *ev);
	// function to (re)draw the lifebar
	static void printLifeBar(SDL_Surface* screen,double life1,double life2);
	
	// main function to run a fight
	static int fight_main(int argc,char** argv,bool memHumanForEval);
};

#define init_fight Fighter::init_fight
#define launch_test_fight Fighter::launch_test_fight
#define fight_main Fighter::fight_main

#endif
