#ifndef _Mate
#define _Mate

#include <iostream>
#include <list>
#include <vector>
#include <algorithm>
#include "Neuron.h"
#include "Functions.h"
#include "IDCounters.h"
#include "Innovation.h"
#include "Neat.h"
#include "Organism.h"

/* ****** MATING METHODS ***** */

/* This method mates this Organism with another Organism g.  
	For every point in each Organism, where each Organism shares
	the innovation number, the Gene is chosen randomly from 
	either parent. If one parent has an innovation absent in 
	the other, the baby will inherit the innovation or not,
	depending of the goodness of the parent */
Organism* mate_multipoint(const Organism* org1,const Organism* org2);
/* This method mates like multipoint but instead of selecting one
	or the other when the innovation numbers match, it averages their
	weights */
Organism* mate_multipoint_avg(const Organism* org1,const Organism* org2);
/* This method is similar to a standard single point CROSSOVER
	operator. A point is chosen in the smaller Organism for crossing
	with the bigger one.  */
Organism* mate_singlepoint(const Organism* org1,const Organism* org2);

#endif
