#ifndef _Mutate
#define _Mutate

#include <iostream>
#include <list>
#include <vector>
#include "Neuron.h"
#include "Functions.h"
#include "IDCounters.h"
#include "Innovation.h"
#include "Neat.h"
#include "Organism.h"

/* ******* MUTATORS ******* */

void mutate_link_weights(Organism* org); /* Change link's weights randomly, around their value */
void randomize_link_weights(Organism* org); /* Change link's weight totally random (for initialization) */
void mutate_toggle_enable(Organism* org,int times); /* toggle links on or off, times times */
void mutate_gene_reenable(Organism* org); /* Find first disabled link and enable it */
void mutate_threshold(Organism* org,int times); /* mutate randomly (slightly) one random node threshold */

/* These last kinds of mutations return false if they fail
	They can fail under certain conditions,  being unable
	to find a suitable place to make the mutation. */
/* Mutate organism by adding a new link between 2 random neuron */
bool mutate_add_link(Organism* org,int times); 
/* Mutate organism by adding a neuron respresentation */
bool mutate_add_node(Organism* org,int times);

#endif
