#include "PigEnv.h"

/*----------------------------------------------------------
	Init, load stuff etc
----------------------------------------------------------*/

int load_level(GAMESTATE *gs, int map) {
	const char *m;
	const char *k;
	if(map > 4) map = 1;
	gs->level = map;
	pig_object_close_all(gs->pe);
	gs->enemycount = 0;
	gs->messages = 0;
	switch(map) {
		case 1:
		case 2:
		case 4:
			k =	"abcd" "efgh" "ijkl"	/* Red, green, yellov */
				"0123456789ABCDEFG"	/* Sky */
				"xyz";			/* Single R, G, Y */
			break;
		case 3:
		default:
			k =	"abcd" "efgh" "ijkl"	/* Red, green, yellov */
				"................."
				"xyz"			/* Single R, G, Y */
				"-+012345..ABCDEF";	/* Night sky */
			break;
	}
	switch(map) {
		case 1: m =	"0000000000000000000000000"
				"1111111111111111111111111"
				"2222222222222222222222222"
				"3333333333333333333333333"
				"4444444444444444444444444"
				"5555555555555555555555555"
				"6666666666666666666666666"
				"7777777ijkjkjjkjkl7777777"
				"8888888888888888888888888"
				"9999999999999999999999999"
				"abcdAAAAAAAAAAAAAAAAAabcd"
				"BBBBBBBBBBBBBBBBBBBBBBBBB"
				"CCCCCCCCCCCCCCCCCCCCCCCCC"
				"efgfgffgfgfgfgfggffgfgfgh"
				"EEEEEEEEEEEEEEEEEEEEEEEEE"
				"FFFFFFFFFFFFFFFFFFFFFFFFF"
				"GGGGGGGGGGGGGGGGGGGGGGGGG";
				new_evil(gs, 2, 0, 5);
				new_evil(gs, 22, 0, 5);
				new_evil(gs, 5, 0, 7);
				new_evil(gs, 19, 0, 7);
				break;
		case 2: m =	"0000000000000000000000000"
				"1111111111111111111111111"
				"2222222222222222222222222"
				"3333333333333333333333333"
				"4444444444xxxxx4444444444"
				"5555555555x555x5555555555"
				"6666666666x666x6666666666"
				"7777777xxxx777xxxx7777777"
				"8888888x888888888x8888888"
				"9999999x999999999x9999999"
				"AAAAAAAxxxxAAAxxxxAAAAAAA"
				"BBBBBBBBBBxBBBxBBBBBBBBBB"
				"CCCCCCCCCCxCCCxCCCCCCCCCC"
				"DDDDDDDDDDxxxxxDDDDDDDDDD"
				"EEEEEEEEEEEEEEEEEEEEEEEEE"
				"ijklFFFFFFFFFFFFFFFFFijkl"
				"GGGijlGilGilGilGilGiklGGG";
				new_slime(gs, 2, 0, -5);
				new_slime(gs, 22, 0, 5);
				new_evil(gs, 8, 0, 7);
				new_evil(gs, 16, 0, -7);
				break;
		case 3: m =	"-------------------------"
				"-------------------------"
				"-------------------------"
				"-------------------------"
				"ijkl----------efgh-------"
				"-------------------------"
				"-------------------------"
				"z----------------abcbcbbd"
				"+++++++++++++++++++++++++"
				"01z3450123450123450123450"
				"ABCDEFABCefgfgfghFABCDEFA"
				"----z--------------------"
				"-------------------------"
				"------z--------------ijkl"
				"-------------------------"
				"-------------------------"
				"abdefghijkl---efghijklabd";
				new_slime(gs, 5, 0, -5);
				new_slime(gs, 20, 15, -5);
				new_evil(gs, 1, 0, 7);
				new_evil(gs, 20, 0, 10);
				new_evil(gs, 15, 0, 7);
				break;
		case 4: m =	"0000000000000000000000000"
				"1111111111111111111111111"
				"2222222222222222222222222"
				"3333333333333333333333333"
				"4444444444444444444444444"
				"555555555555z555555555555"
				"66666666666ijl66666666666"
				"7777777777ijlil7777777777"
				"888888888ijlikkl888888888"
				"99999999ijkjklikl99999999"
				"AAAAAAAikjlijkjkjlAAAAAAA"
				"BBBBBBiklijkjlijkjlBBBBBB"
				"CCCCCijkjlikkjklikklCCCCC"
				"DDDDijklijjklikjkjkklDDDD"
				"EEEijkkjkjlikjkjlijjklEEE"
				"FFijkjlilijkjklikjlikklFF"
				"efggfggfgfgfggfgfgfgfgfgh";
				new_evil(gs, 10, 0, 5);
				new_evil(gs, 9, 0, 6);
				new_evil(gs, 8, 0, 7);
				new_evil(gs, 7, 0, 8);
				new_evil(gs, 6, 0, 9);
				new_evil(gs, 5, 0, 10);
				new_evil(gs, 4, 0, 11);
				new_evil(gs, 3, 0, 12);
				new_evil(gs, 2, 0, 13);
				new_slime(gs, 1, 0, 16);
				new_slime(gs, 24, 0, -14);
				break;
		default:
			return -1;
	}
	pig_map_from_string(gs->pe->map, k, m);
	gs->refresh_screen = gs->pe->pages;
	return 0;
}

int load_map_level(GAMESTATE *gs, int map) {
	const char *m;
	const char *k;
	gs->messages = 0;
	switch(map) {
		case 1:
		case 2:
		case 4:
			k =	"abcd" "efgh" "ijkl"	/* Red, green, yellov */
				"0123456789ABCDEFG"	/* Sky */
				"xyz";			/* Single R, G, Y */
			break;
		case 3:
		default:
			k =	"abcd" "efgh" "ijkl"	/* Red, green, yellov */
				"................."
				"xyz"			/* Single R, G, Y */
				"-+012345..ABCDEF";	/* Night sky */
			break;
	}
	switch(map) {
		case 1: m =	"0000000000000000000000000"
				"1111111111111111111111111"
				"2222222222222222222222222"
				"3333333333333333333333333"
				"4444444444444444444444444"
				"5555555555555555555555555"
				"6666666666666666666666666"
				"7777777ijkjkjjkjkl7777777"
				"8888888888888888888888888"
				"9999999999999999999999999"
				"abcdAAAAAAAAAAAAAAAAAabcd"
				"BBBBBBBBBBBBBBBBBBBBBBBBB"
				"CCCCCCCCCCCCCCCCCCCCCCCCC"
				"efgfgffgfgfgfgfggffgfgfgh"
				"EEEEEEEEEEEEEEEEEEEEEEEEE"
				"FFFFFFFFFFFFFFFFFFFFFFFFF"
				"GGGGGGGGGGGGGGGGGGGGGGGGG";
				break;
		case 2: m =	"0000000000000000000000000"
				"1111111111111111111111111"
				"2222222222222222222222222"
				"3333333333333333333333333"
				"4444444444xxxxx4444444444"
				"5555555555x555x5555555555"
				"6666666666x666x6666666666"
				"7777777xxxx777xxxx7777777"
				"8888888x888888888x8888888"
				"9999999x999999999x9999999"
				"AAAAAAAxxxxAAAxxxxAAAAAAA"
				"BBBBBBBBBBxBBBxBBBBBBBBBB"
				"CCCCCCCCCCxCCCxCCCCCCCCCC"
				"DDDDDDDDDDxxxxxDDDDDDDDDD"
				"EEEEEEEEEEEEEEEEEEEEEEEEE"
				"ijklFFFFFFFFFFFFFFFFFijkl"
				"GGGijlGilGilGilGilGiklGGG";
				break;
		case 3: m =	"-------------------------"
				"-------------------------"
				"-------------------------"
				"-------------------------"
				"ijkl----------efgh-------"
				"-------------------------"
				"-------------------------"
				"z----------------abcbcbbd"
				"+++++++++++++++++++++++++"
				"01z3450123450123450123450"
				"ABCDEFABCefgfgfghFABCDEFA"
				"----z--------------------"
				"-------------------------"
				"------z--------------ijkl"
				"-------------------------"
				"-------------------------"
				"abdefghijkl---efghijklabd";
				break;
		case 4: m =	"0000000000000000000000000"
				"1111111111111111111111111"
				"2222222222222222222222222"
				"3333333333333333333333333"
				"4444444444444444444444444"
				"555555555555z555555555555"
				"66666666666ijl66666666666"
				"7777777777ijlil7777777777"
				"888888888ijlikkl888888888"
				"99999999ijkjklikl99999999"
				"AAAAAAAikjlijkjkjlAAAAAAA"
				"BBBBBBiklijkjlijkjlBBBBBB"
				"CCCCCijkjlikkjklikklCCCCC"
				"DDDDijklijjklikjkjkklDDDD"
				"EEEijkkjkjlikjkjlijjklEEE"
				"FFijkjlilijkjklikjlikklFF"
				"efggfggfgfgfggfgfgfgfgfgh";
				break;
		default:
			return -1;
	}
	pig_map_from_string(gs->pe->map, k, m);
	gs->refresh_screen = gs->pe->pages;
	return 0;
}

GAMESTATE *init_all(SDL_Surface *screen) {
	int i;
	PIG_map *pm;
	GAMESTATE *gs = (GAMESTATE *)calloc(1, sizeof(GAMESTATE));
	if(!gs)
		return NULL;

	gs->running = 1;

	gs->pe = pig_open(screen);
	if(!gs->pe)
	{
		fprintf(stderr, "Could not open the Pig Engine!\n");
		free(gs);
		return NULL;
	}
	gs->pe->userdata = gs;

	pig_viewport(gs->pe, 0, 0, SCREEN_W, MAP_H * TILE_H);

	i = gs->lifepig = pig_sprites(gs->pe, "picsPig/lifepig.png", 0, 0);
	i |= gs->scorefont = pig_sprites(gs->pe, "picsPig/font.png", 44, 56);
	i |= gs->glassfont = pig_sprites(gs->pe, "picsPig/glassfont.png", 60, 60);
	i |= gs->icons = pig_sprites(gs->pe, "picsPig/icons.png", 48, 48);
	i |= gs->stars = pig_sprites(gs->pe, "picsPig/stars.png", 32, 32);
	i |= gs->pigframes = pig_sprites(gs->pe, "picsPig/pigframes.png", 64, 48);
	i |= gs->evil = pig_sprites(gs->pe, "picsPig/evil.png", 48, 48);
	i |= gs->slime = pig_sprites(gs->pe, "picsPig/slime.png", 48, 48);
	if(i < 0)
	{
		fprintf(stderr, "Could not load graphics!\n");
		pig_close(gs->pe);
		free(gs);
		return NULL;
	}
	for(i = gs->icons; i < gs->icons + 3*8; ++i)
		pig_hotspot(gs->pe, i, PIG_CENTER, 45);
	for(i = gs->pigframes; i < gs->pigframes + 12; ++i)
		pig_hotspot(gs->pe, i, PIG_CENTER, 43);
	for(i = gs->evil; i < gs->evil + 16; ++i)
		pig_hotspot(gs->pe, i, PIG_CENTER, 46);

	pm = pig_map_open(gs->pe, MAP_W, MAP_H);
	if(!pm)
	{
		fprintf(stderr, "Could not create map!\n");
		pig_close(gs->pe);
		free(gs);
		return NULL;
	}
	if(pig_map_tiles(pm, "picsPig/tiles.png", TILE_W, TILE_H) < 0)
	{
		fprintf(stderr, "Could not load background graphics!\n");
		pig_close(gs->pe);
		free(gs);
		return NULL;
	}

	/* Mark tiles for collision detection */
	pig_map_collisions(pm, 0, 12, PIG_ALL);	/* Red, green, yellov */
	pig_map_collisions(pm, 12, 17, PIG_NONE);/* Sky */
	pig_map_collisions(pm, 29, 3, PIG_ALL);	/* Single R, G, Y */

	return gs;
}

/*----------------------------------------------------------
	Render the dashboard
----------------------------------------------------------*/
void dashboard(GAMESTATE *gs)
{
	SDL_Rect r;
	int i, v;
	double x;
	r.x = 0;
	r.y = SCREEN_H - 56;
	r.w = SCREEN_W;
	r.h = 56;
	SDL_SetClipRect(gs->pe->surface, &r);

	/* draw the score/life bar */
	for(i = 0; i < 56; ++i)
	{
		SDL_Rect cr;
		cr.x = 0;
		cr.w = SCREEN_W;
		cr.y = SCREEN_H - 56 + i;
		cr.h = 1;
		SDL_FillRect(gs->pe->surface,&cr, SDL_MapRGB(gs->pe->surface->format,25,50,75));
	}

	/* Draw pigs... uh, lives! */
	x = -10;
	for(i = 0; i < gs->lives; ++i)
	{
		x += 48;
		pig_draw_sprite(gs->pe, gs->lifepig,(int)(x + i * 1.7),SCREEN_H - 56/2);
	}

	/* Print score */
	x = SCREEN_W + 5;
	v = gs->score;
	for(i = 9; i >= 0; --i)
	{
		int n = v % 10;
		x -= 39 + i * .5;
		pig_draw_sprite(gs->pe, gs->scorefont + n, (int)x,SCREEN_H - 56/2);
		v /= 10;
		if(!v)
			break;
	}

	pig_dirty(gs->pe, &r);
}

/*----------------------------------------------------------
	Game logic event handlers
----------------------------------------------------------*/

void star_handler(PIG_object *po, const PIG_event *ev)
{
	switch(ev->type)
	{
	  case PIG_PREFRAME:
		if(po->age >= 8)
			pig_object_close(po);
		else
			po->image = po->age;
	  default:
		break;
	}
}

void evil_handler(PIG_object *po, const PIG_event *ev)
{
	GAMESTATE *gs = (GAMESTATE *)po->owner->userdata;
	int look_x;
	switch(ev->type)
	{
	  case PIG_PREFRAME:
		if(DEAD == po->state)
			break;
		po->ax = (po->target - po->vx) * .5;
		po->ay = GRAV_ACC;
		po->image = po->age % 16;
		break;
	  case PIG_HIT_TILE:
		if(DEAD == po->state)
			break;
		po->vy = 0;
		po->ay = 0;
		po->x = ev->cinfo.x + po->vx;
		po->y = ev->cinfo.y;
		break;
	  case PIG_OFFSCREEN:
		if(po->y > SCREEN_H)
		{
			pig_object_close(po);
			--gs->enemycount;
		}
		break;
	  case PIG_POSTFRAME:
		if(DEAD == po->state)
			break;
		look_x = (int)fabs(po->vx * 2)+10;
		if(po->target < 0)
			look_x = -look_x;
		if(!pig_test_map(po->owner, (int)(po->x) + look_x, (int)(po->y) + 1))
			po->target = -po->target;
	  default:
		break;
	}
}

void slime_handler(PIG_object *po, const PIG_event *ev) {
	GAMESTATE *gs = (GAMESTATE *)po->owner->userdata;
	int look_x;
	switch(ev->type)
	{
	  case PIG_PREFRAME:
		if(DEAD == po->state)
			break;
		po->ax = (po->target - po->vx) * .2;
		po->ay = GRAV_ACC;
		po->image = po->age % 16;
		break;
	  case PIG_HIT_TILE:
		po->vy = -(JUMP_SPEED + GRAV_ACC);
		po->ay = 0;
		po->y = ev->cinfo.y;
		break;
	  case PIG_OFFSCREEN:
		if(po->y > SCREEN_H)
		{
			pig_object_close(po);
			--gs->enemycount;
		}
		break;
	  case PIG_POSTFRAME:
		if(DEAD == po->state)
			break;
		/* Don't bother looking if we're close to a floor. */
		if(pig_test_map_vector(po->owner,(int)(po->x),(int)(po->y),(int)(po->x),(int)(po->y) + 48,PIG_TOP, NULL))
			break;
		/* Turn around if there's no floor! */
		look_x = (int)fabs(po->vx * 4)+10;
		if(po->target < 0)
			look_x = -look_x;
		if(!pig_test_map_vector(po->owner,(int)(po->x) + look_x,(int)(po->y),(int)(po->x) + look_x, SCREEN_H,PIG_TOP, NULL))
			po->target = -po->target;
	  default:
		break;
	}
}

void chain_head_handler(PIG_object *po, const PIG_event *ev)
{
	GAMESTATE *gs = (GAMESTATE *)po->owner->userdata;
	switch(ev->type)
	{
	  case PIG_PREFRAME:
		po->vx = (po->target - po->x) * .3;
		po->vy = 15 * cos(po->age * .3) - 9;
		if((gs->messages > 1) && (1 == po->state))
			po->timer[1] = 0;
		if(po->timer[1])
			break;
	  case PIG_TIMER1:
		switch(po->state)
		{
		  case 0:
			po->timer[1] = 35;
			++po->state;
			break;
		  case 1:
			po->target = -SCREEN_W;
			po->timer[1] = 50;
			++po->state;
			if(gs->messages > 0)
				--gs->messages;
			break;
		  case 2:
			pig_object_close(po);
			break;
		}
	  default:
		break;
	}
}

void chain_link_handler(PIG_object *po, const PIG_event *ev)
{
	PIG_object *target = pig_object_find(po, po->target);
	switch(ev->type)
	{
	  case PIG_PREFRAME:
		if(target)
		{
			po->vx = ((target->x + FONT_SPACING) - po->x) * .6;
			po->vy = (target->y - po->y) * .6 - 9;
		}
		else
			pig_object_close(po);
	  default:
		break;
	}
}

/*----------------------------------------------------------
	Accounting (score, lives etc)
----------------------------------------------------------*/

void add_life(GAMESTATE *gs)
{
	++gs->lives;
}


void remove_life(GAMESTATE *gs)
{
	--gs->lives;
}

void inc_score(GAMESTATE *gs, int v)
{
	gs->score += v;
}

PIG_object *new_star(GAMESTATE *gs, int x, int y, int vx, int vy)
{
	PIG_object *po = pig_object_open(gs->pe, x + vx, y + vy, 1);
	if(!po)
		return NULL;

	po->ibase = gs->stars;
	po->ax = -vx * 0.3;
	po->vx = vx * 3;
	po->ay = -vy * 0.3;
	po->vy = vy * 3;
	po->handler = star_handler;
	po->type=0;
	return po;
}

PIG_object *new_evil(GAMESTATE *gs,int x, int y, int speed)
{
	PIG_object *po = pig_object_open(gs->pe,
			x * TILE_W, y * TILE_H, 1);
	if(!po)
		return NULL;

	po->rank=gs->enemycount;
	++gs->enemycount;
	po->ibase = gs->evil;
	po->target = speed;
	po->handler = evil_handler;
	po->score = 200;
	po->tilemask = PIG_TOP;
	po->hitgroup = GROUP_ENEMY;
	po->type=1;
	return po;
}

PIG_object *new_slime(GAMESTATE *gs,
		int x, int y, int speed)
{
	PIG_object *po = pig_object_open(gs->pe,
			x * TILE_W, y * TILE_H, 1);
	if(!po)
		return NULL;

	++gs->enemycount;
	po->ibase = gs->slime;
	po->target = speed;
	po->handler = slime_handler;
	po->score = 300;
	po->tilemask = PIG_TOP;
	po->hitgroup = GROUP_ENEMY;
	po->type=1;
	return po;
}

PIG_object *new_chain_head(GAMESTATE *gs,
		int x, int y, int image, int target_x)
{
	PIG_object *po = pig_object_open(gs->pe, x, y, 1);
	if(!po)
		return NULL;

	po->ibase = image;
	po->handler = chain_head_handler;
	po->target = target_x;
	po->type=0;
	return po;
}


PIG_object *new_chain_link(GAMESTATE *gs,
		int x, int y, int image, int target)
{
	PIG_object *po = pig_object_open(gs->pe, x, y, 1);
	if(!po)
		return NULL;

	po->ibase = image;
	po->handler = chain_link_handler;
	po->target = target;
	po->type=0;
	return po;
}

void message(GAMESTATE *gs, const char *s)
{
	int i = 0;
	const int x = SCREEN_W + FONT_SPACING;
	const int y = MAP_H * TILE_H - 30;
	int tx = (SCREEN_W - ((signed)strlen(s) - 1) * FONT_SPACING) / 2;
	PIG_object *po = NULL;
	while(s[i])
	{
		int c = toupper(s[i]) - 32 + gs->glassfont;
		if(0 == i)
			po = new_chain_head(gs, x, y, c, tx);
		else
			po = new_chain_link(gs, x, y, c, po->id);
		if(!po)
			return;
		++i;
	}
	++gs->messages;
}

/*----------------------------------------------------------
	Input; events and game control keys
----------------------------------------------------------*/

void handle_input(GAMESTATE *gs, SDL_Event *ev)
{
	switch(ev->type)
	{
	  case SDL_MOUSEBUTTONUP:
		break;
	  case SDL_KEYDOWN:
		switch(ev->key.keysym.sym)
		{
		  case SDLK_UP:
			gs->jump = 3;
			break;
		  case SDLK_F1:
			gs->pe->interpolation = !gs->pe->interpolation;
			if(gs->pe->interpolation)
				message(gs, "Interpolation: ON");
			else
				message(gs, "Interpolation: OFF");
			break;
		  case SDLK_F2:
			gs->pe->direct = !gs->pe->direct;
			if(gs->pe->direct)
				message(gs, "Rendering: Direct");
			else
				message(gs, "Rendering: Buffered");
			break;
		  case SDLK_F3:
			gs->pe->show_dirtyrects = !gs->pe->show_dirtyrects;
			if(gs->pe->show_dirtyrects)
				message(gs, "Dirtyrects: ON");
			else
				message(gs, "Dirtyrects: OFF");
			break;
		  case SDLK_F4:
			gs->nice = !gs->nice;
			if(gs->nice)
				message(gs, "Be Nice: ON");
			else
				message(gs, "Be Nice: OFF");
			break;
		  default:
			break;
		}
		break;
	  case SDL_KEYUP:
		switch(ev->key.keysym.sym)
		{
		  case SDLK_ESCAPE:
			gs->running = 0;
		  default:
			break;
		}
		break;
	  case SDL_QUIT:
		gs->running = 0;
		break;
	}
}
