#ifndef _PigEnv
#define _PigEnv

#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <ctype.h>
#include <windows.h>
#include <cmath>
#include "PigEngine.h"
#include <fstream>
#include "Organism.h"
#include <iostream>
#include "DrawNetwork.h"
#include "Functions.h"
#include "Neuron.h"
#include "PigUtiles.h"

int load_level(GAMESTATE *gs,int map);
int load_map_level(GAMESTATE *gs,int map);
GAMESTATE *init_all(SDL_Surface *screen);
void dashboard(GAMESTATE *gs);
void star_handler(PIG_object *po, const PIG_event *ev);
void evil_handler(PIG_object *po, const PIG_event *ev);
void slime_handler(PIG_object *po, const PIG_event *ev);
void chain_head_handler(PIG_object *po, const PIG_event *ev);
void chain_link_handler(PIG_object *po, const PIG_event *ev);
void add_life(GAMESTATE *gs);
void remove_life(GAMESTATE *gs);
void inc_score(GAMESTATE *gs, int v);
PIG_object *new_star(GAMESTATE *gs, int x, int y, int vx, int vy);
PIG_object *new_evil(GAMESTATE *gs,int x, int y, int speed);
PIG_object *new_slime(GAMESTATE *gs,int x, int y, int speed);
PIG_object *new_chain_head(GAMESTATE *gs,int x, int y, int image, int target_x);
PIG_object *new_chain_link(GAMESTATE *gs,int x, int y, int image, int target);
void message(GAMESTATE *gs, const char *s);
void handle_input(GAMESTATE *gs, SDL_Event *ev);

#endif
